﻿using Mvc_TreeView.Models;
using System.Collections.Generic;
using System.Web.Mvc;

namespace Mvc_TreeView.Controllers
{
    public class HomeController : Controller
    {
        CapituloContexto db = new CapituloContexto();

        // GET: Home
        public ActionResult Index()
        {
            //obtem a lista para passar os dados para a view
            IList<Modelo> capitulos = ListaCapitulo();
            return View(capitulos);
        }

        public IList<Modelo> ListaCapitulo()
        {
            IList<Modelo> capitulos = new List<Modelo>();

            foreach (var capitulo in db.Capitulos)
            {
                var cap = new Modelo
                {
                    Id = capitulo.CapituloID,
                    Nome = capitulo.Nome,
                    Tipo = "capitulo"
                };

                foreach (var topico in capitulo.Topicos)
                {
                    var top = new Modelo
                    {
                        Id = topico.TopicoID,
                        Nome = topico.Nome,
                        Tipo = "topico"
                    };

                    foreach (var subtopico in topico.SubTopicos)
                    {
                        var subtop = new Modelo
                        {
                            Id = subtopico.SubTopicoID,
                            Nome = subtopico.Nome,
                            Tipo = "subtopico"
                        };

                        top.Lista.Add(subtop);
                    }

                    cap.Lista.Add(top);
                }

                capitulos.Add(cap);
            }

            return capitulos;
        }
    }
}