﻿using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;

namespace Mvc_TreeView.Models
{
    public class ModelInitializer : DropCreateDatabaseIfModelChanges<CapituloContexto>
    {
        protected override void Seed(CapituloContexto ctx)
        {
            var capitulos = new List<Capitulo>
            {
                new Capitulo
                {
                    Nome = "Modelo de Relacionamento de Entidade"
                },
                new Capitulo
                {
                    Nome ="Modelo Relacional"
                },
                new Capitulo
                {
                    Nome = "Normalização"
                }
            };

            var topicos = new List<Topico>
            {
                new Topico
                {
                    Nome = "Entity e Entity sets",
                    Capitulo = capitulos.Single(m => m.Nome == "Modelo de Relacionamento de Entidade")
                },
                new Topico
                {
                    Nome = "Mapeando de Restrições e Chave Primária ",
                    Capitulo = capitulos.Single(m => m.Nome == "Modelo de Relacionamento de Entidade")
                },
                new Topico
                {
                    Nome = "Diagrama Entidade Relacionamento",
                    Capitulo = capitulos.Single(m => m.Nome == "Modelo de Relacionamento de Entidade")
                },
                new Topico
                {
                    Nome = "Restrições de Integridade",
                    Capitulo = capitulos.Single(m => m.Nome == "Modelo Relacional")
                },
                new Topico
                {
                    Nome = "Álgebra Relacional",
                    Capitulo = capitulos.Single(m => m.Nome == "Modelo Relacional")
                },
                new Topico
                {
                    Nome = "Modificando o banco de dados",
                    Capitulo = capitulos.Single(m => m.Nome == "Modelo Relacional")
                },
                new Topico
                {
                    Nome = "Introdução a dependência funcional",
                    Capitulo = capitulos.Single(m => m.Nome == "Normalização")
                },
                new Topico
                {
                    Nome = "Normalização 1NF,2NF,3NF,BCNF,4NF,5NF",
                    Capitulo = capitulos.Single(m => m.Nome == "Normalização")
                }
            };

            var subtopicos = new List<SubTopico>
            {
                new SubTopico
                {
                    Nome = "Entidades",
                    Topico = topicos.Single(m => m.Nome == "Diagrama Entidade Relacionamento")
                },
                new SubTopico
                {
                    Nome = "Seleção, Projeção",
                    Topico = topicos.Single(m => m.Nome == "Álgebra Relacional")
                },
                new SubTopico
                {
                    Nome = "Dependências Funcionais Mínimas",
                    Topico = topicos.Single(m => m.Nome == "Introdução a dependência funcional")
                },
                new SubTopico
                {
                    Nome = "Dependências Funcionais Equivalentes",
                    Topico = topicos.Single(m => m.Nome == "Introdução a dependência funcional")
                }
            };

            capitulos.ForEach(m => ctx.Capitulos.Add(m));
            topicos.ForEach(m => ctx.Topicos.Add(m));
            subtopicos.ForEach(m => ctx.SubTopicos.Add(m));
        }
    }
}